VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBitmapDC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

  Private Type Rect
     Left As Long
     Top As Long
     Right As Long
     Bottom As Long
  End Type

  
Private Type GUID
   Data1 As Long
   Data2 As Integer
   Data3 As Integer
   Data4(7) As Byte
End Type
  


Private Declare Function GetDC Lib "USER32" ( _
    ByVal hWnd As Long) As Long
Private Declare Function CreateCompatibleDC Lib "GDI32" ( _
   ByVal hDC As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "GDI32" ( _
   ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long _
   ) As Long
Private Declare Function SelectObject Lib "GDI32" (ByVal hDC As Long, _
   ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "GDI32" (ByVal hDCDest As Long, _
   ByVal XDest As Long, ByVal YDest As Long, ByVal nWidth As Long, _
   ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal XSrc As Long, _
   ByVal YSrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "GDI32" (ByVal hDC As Long) As Long
Private Declare Function ReleaseDC Lib "USER32" (ByVal hWnd As Long, _
   ByVal hDC As Long) As Long

  
  
  
  Private Type PicBmp
     Size As Long
     Type As Long
     hBmp As Long
     hPal As Long
     Reserved As Long
  End Type

  Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" ( _
     PicDesc As PicBmp, RefIID As GUID, _
     ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
 



'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' CreateBitmapPicture
'    - Creates a bitmap type Picture object from a bitmap and palette
'
' hBmp
'    - Handle to a bitmap
'
' hPal
'    - Handle to a Palette
'    - Can be null if the bitmap doesn't use a palette
'
' Returns
'    - Returns a Picture object containing the bitmap
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
   Public Function CreateBitmapPicture(ByVal hBmp As Long, _
     ByVal hPal As Long) As Picture
 
      Dim r As Long
   Dim pic As PicBmp
   ' IPicture requires a reference to "Standard OLE Types"
   Dim IPic As IPicture
   Dim IID_IDispatch As GUID
 
   ' Fill in with IDispatch Interface ID
   With IID_IDispatch
      .Data1 = &H20400
      .Data4(0) = &HC0
      .Data4(7) = &H46
   End With
 
   ' Fill Pic with necessary parts
   With pic
      .Size = Len(pic)          ' Length of structure
      .Type = vbPicTypeBitmap   ' Type of Picture (bitmap)
      .hBmp = hBmp              ' Handle to bitmap
      .hPal = hPal              ' Handle to palette (may be null)
   End With
 
   ' Create Picture object
   r = OleCreatePictureIndirect(pic, IID_IDispatch, 1, IPic)
 
   ' Return the new Picture object
   Set CreateBitmapPicture = IPic
End Function
Public Function CreateBitmapInMemory(Width As Long, Height As Long, Optional CompatibleDC As Long = 0) As Long
  'Create a bitmap in memory and return the HDC for this bitmap
   Dim hDCMemory As Long 'Memory device context for the map
   hDCMemory = CreateCompatibleDC(CompatibleDC)
   CreateBitmapInMemory = CreateCompatibleBitmap(CompatibleDC, Width, Height)
   DeleteDC hDCMemory
End Function


Public Function PasteBitmap(ByRef Hdcdestination As Long, DestinationLeft As Long, DestinationTop As Long _
 , HDCSource As Long, SourceLeft As Long, SourceTop As Long, SourceWidth As Long, SourceHeight As Long _
 , Optional RasterOperation As Double = vbSrcCopy) As Boolean
  
  Dim oldDC As Long
  Dim hDCMemory As Long
  Dim HdcBitmap As Long
  Dim r As Long
  
  hDCMemory = CreateCompatibleDC(HDCSource)
   
  oldDC = SelectObject(hDCMemory, Hdcdestination)
  
  r = BitBlt(hDCMemory, DestinationLeft, DestinationTop, SourceWidth, SourceHeight _
  , HDCSource, SourceLeft, SourceTop, RasterOperation)

 
  Hdcdestination = SelectObject(hDCMemory, oldDC)
    
  
  DeleteDC hDCMemory
End Function

