VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsLegendRenderer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_PictureBox As PictureBox 'local copy
Private mRendererWidth As Integer
Private mRendererHeight As Integer
Private OldScaleMode As Byte

Private Declare Function CreatePen Lib "GDI32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function CreateSolidBrush Lib "GDI32" (ByVal crColor As Long) As Long
Private Declare Function SelectObject Lib "GDI32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function Polygon Lib "GDI32" (ByVal hDC As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function DeleteObject Lib "GDI32" (ByVal hObject As Long) As Long


Private Type POINTAPI
        X As Long
        Y As Long
End Type
Private Const PS_SOLID = 0

Public Property Set PictureBox(ByVal vData As PictureBox)
    Set m_PictureBox = vData
    OldScaleMode = m_PictureBox.ScaleMode
End Property


Public Property Get PictureBox() As PictureBox
    Set PictureBox = m_PictureBox
End Property

Public Sub AddEntry(IsMA As Boolean, sym As MapObjects2.Symbol, Top As Long, Left As Long)
'  Set the map layer name, then get layer info from
'  the layerinfo file.  Set the caption and draw the
'  layer's symbol.

If sym Is Nothing Then
  Exit Sub
End If

Dim symboltype As Integer
Dim Symbolcolor As Long
Dim SymbolStyle As Integer
If Not IsMA Then
  symboltype = sym.symboltype
  Symbolcolor = sym.color
  SymbolStyle = sym.Style
Else
  symboltype = 2
  Symbolcolor = moMagenta
  SymbolStyle = 0
End If

m_PictureBox.CurrentX = Left
m_PictureBox.CurrentY = Top

m_PictureBox.ScaleMode = vbPixels
Select Case symboltype
  Case 0  ' Point
    Call DrawMarker(sym)
  Case 1  ' Line
    Call DrawLine(Symbolcolor, sym.Size)
  Case 2  ' Polygon fill
    Call DrawShade(Symbolcolor, SymbolStyle, sym.OutlineColor)
End Select
m_PictureBox.ScaleMode = OldScaleMode
'Symbolcolor = moWhite
End Sub
Public Property Get RendererWidth() As Integer
   RendererWidth = mRendererWidth
End Property

Public Property Let RendererWidth(ByVal vNewValue As Integer)
  mRendererWidth = vNewValue
End Property
Public Property Get RendererHeight() As Integer
   RendererHeight = mRendererHeight
End Property

Public Property Let RendererHeight(ByVal vNewValue As Integer)
  mRendererHeight = vNewValue
End Property

Private Sub DrawMarker(sym As MapObjects2.Symbol)
  Dim xCenter As Integer, yCenter As Integer, Radius As Integer, gap As Integer
  Dim color As Long, olColor As Long
  Dim mstyle As Integer
  Dim CurrentX As Single
  Dim CurrentY As Single
  Dim lX As Long, lY As Long
   ' Draw a marker symbol in the legend box.
  color = sym.color
  If sym.Outline Then
    olColor = sym.OutlineColor
  Else
    olColor = color
  End If
  mstyle = sym.Style
  xCenter = mRendererWidth / 2
  yCenter = mRendererHeight / 2

With m_PictureBox
     
     .FillStyle = 0
     .FillColor = color
     .BorderStyle = 0
   
   Select Case mstyle
    Case 0 'mocircle
      lX = .CurrentX
      lY = .CurrentY
      xCenter = mRendererWidth / 2
      yCenter = mRendererHeight / 2
      Radius = xCenter * 0.5
      m_PictureBox.Circle (.CurrentX + xCenter, .CurrentY + yCenter), Radius, color
      m_PictureBox.FillStyle = vbFSTransparent
      m_PictureBox.Circle (lX + xCenter, lY + yCenter), Radius, olColor
    
    Case 1 'mosquare
      '.ScaleMode = vbPixels
      gap = mRendererHeight * 0.7
      Dim sPoints(4) As POINTAPI
      sPoints(1).X = .CurrentX + gap
      sPoints(1).Y = .CurrentY + gap
      sPoints(2).X = .CurrentX + mRendererWidth - gap
      sPoints(2).Y = .CurrentY + gap
      sPoints(3).X = .CurrentX + mRendererWidth - gap
      sPoints(3).Y = .CurrentY + mRendererHeight - gap
      sPoints(4).X = .CurrentX + gap
      sPoints(4).Y = .CurrentY + mRendererHeight - gap
      
      FillPolygon .hDC, sPoints(1), 4, olColor, color
      '.ScaleMode = vbTwips
      Erase sPoints
    Case 2 'moTriangle
      '.ScaleMode = vbPixels
      gap = .ScaleHeight * 0.35
      lX = .CurrentX
      lY = .CurrentY
      ReDim TPoints(3) As POINTAPI
      TPoints(1).X = .CurrentX + mRendererWidth / 2
      TPoints(1).Y = .CurrentY '+ gap
      TPoints(2).X = .CurrentX + mRendererWidth - gap
      TPoints(2).Y = .CurrentY + gap 'mRendererHeight - gap
      TPoints(3).X = .CurrentX + gap
      TPoints(3).Y = lY + gap 'Y '- gap '+ mRendererHeight - gap
'     Good Upside down points
'      TPoints(1).X = .CurrentX + mRendererWidth / 2
'      TPoints(1).Y = .CurrentY + gap
'      TPoints(2).X = .CurrentX + mRendererWidth - gap
'      TPoints(2).Y = .CurrentY + mRendererHeight - gap
'      TPoints(3).X = .CurrentX + gap
'      TPoints(3).Y = .CurrentY + mRendererHeight - gap
      
      FillPolygon .hDC, TPoints(1), 3, olColor, color
      '.ScaleMode = vbTwips
      Erase sPoints
  Case 3 'cross
     gap = .Height * 0.15
     Debug.Print "Gap: " & gap
     CurrentX = .CurrentX
     CurrentY = .CurrentY
     m_PictureBox.Line (CurrentX + 13, CurrentY + (mRendererHeight / 2))-(CurrentX - 3, CurrentY + (mRendererHeight / 2)), color
     'm_PictureBox.Line (CurrentX + gap + 0, CurrentY + (mRendererHeight / 2))-(CurrentX + mRendererWidth - gap, CurrentY + (mRendererHeight / 2)), color
     m_PictureBox.Line (CurrentX + (mRendererWidth / 2), CurrentY + 13)-(CurrentX + (mRendererWidth / 2), CurrentY - 3), color
      Debug.Print mRendererWidth
      Debug.Print mRendererHeight
  Case 4 'true type font
    Call DrawMarkerFont(color, sym.Size, sym.Font.Name, Chr(sym.CharacterIndex))
   
   
   End Select
     .FillStyle = 0
     .FillColor = color
End With

End Sub
Private Sub DrawMarkerFont(color As Long, Size As Integer, Font As String, Pattern As String)

   ' Draw a marker symbol in the legend box.
   'MsgBox Font
   Dim OldColor As Long
   Dim OldFontName As String
   Dim OldFontSize As Byte
   With m_PictureBox
     'Backup the ld values
     OldColor = .ForeColor
     OldFontName = .FontName
     OldFontSize = .FontSize
     
     .ForeColor = color
     .FontName = Font
     .FontSize = Size
     .CurrentX = .CurrentX + (mRendererWidth / 2) - (.TextWidth(Pattern) / 2)
     .CurrentY = .CurrentY + (mRendererHeight / 2) - (.TextHeight(Pattern) / 2)
   
     m_PictureBox.Print (Pattern)
   
     .ForeColor = OldColor
     .FontName = OldFontName
     .FontSize = OldFontSize
   
   End With
   
End Sub

Private Sub DrawLine(color As Long, Size As Integer)
  
  '  draw a sample of the layer's line symbol.
  Dim OldColor As Long
  Dim OldDrawWidth As Byte
  
  Dim CurrentX As Single
  Dim CurrentY As Single
  
  
  
  With m_PictureBox
     OldColor = .ForeColor
     OldDrawWidth = .DrawWidth
     CurrentX = .CurrentX
     CurrentY = .CurrentY

    
    If Size > 0 Then
      .DrawWidth = IIf(Size < 10, Size, 5)
    End If
    .ForeColor = color
    m_PictureBox.Line (CurrentX, CurrentY + mRendererHeight)-(CurrentX + (mRendererWidth * 0.45), CurrentY + (mRendererHeight * 0.3))
    m_PictureBox.Line (CurrentX + (mRendererWidth * 0.45), CurrentY + (mRendererHeight * 0.3))-(CurrentX + (mRendererWidth * 0.55), CurrentY + (mRendererHeight * 0.7))
    m_PictureBox.Line (CurrentX + (mRendererWidth * 0.55), CurrentY + (mRendererHeight * 0.7))-(CurrentX + (mRendererWidth), CurrentY)
     
    .ForeColor = OldColor
    .DrawWidth = OldDrawWidth
  
  End With
  
End Sub

Private Sub DrawShade(color As Long, mstyle As Integer, Optional OutlineColor As Long = 0)
 
   '  fill the legend box with a shade.
   Dim OldFillColor As Long
   Dim OldFillStyle As Byte
   Dim CurX As Long, CurY As Long
   With m_PictureBox
     OldFillColor = .FillColor
     OldFillStyle = .FillStyle
     
     .FillColor = color
     
     If mstyle <= 7 Then
        .FillStyle = mstyle
        If mstyle = 1 Then
          .FillColor = OutlineColor
          color = OutlineColor
        End If
       Else
        .FillStyle = 0 'solid
     End If
     '.BorderStyle = 1  ' Single line
     CurX = .CurrentX
     CurY = .CurrentY - 1
      m_PictureBox.Line (.CurrentX, CurY)-(.CurrentX + mRendererWidth, CurY + mRendererHeight), color, B
      If mstyle <> 1 Then
        .FillStyle = 1
        m_PictureBox.Line (CurX, CurY)-(CurX + mRendererWidth, CurY + mRendererHeight), OutlineColor, B
      End If
   
     .FillColor = OldFillColor
     .FillStyle = OldFillStyle

   End With
     
End Sub

Private Function FillPolygon(hdcDevice As Long, ptStartPoint As POINTAPI, iPointCount As Integer, crOutlineColor As Long, crFillColor As Long) As Long

  '  Draws a solid-filled polygon in the specified device context.
  
  Dim hPen As Long          ' New pen we will create
  Dim hBrush As Long        ' New brush we will create
  Dim hOldPen As Long       ' Holder for old pen
  Dim hOldBrush As Long     ' Holder for old brush
  
  hPen = CreatePen(PS_SOLID, 1, crOutlineColor)
  hBrush = CreateSolidBrush(crFillColor)
  
  '  Save the old pen and brush
  
  hOldPen = SelectObject(hdcDevice, hPen)
  hOldBrush = SelectObject(hdcDevice, hBrush)
  
  'Fill the polygon.  Arguments are the display HDC, the first point in
  'the array, and the number of points in the array.
  'Return is non-zero if succesful, zero if failed.
  
  Dim r As Long
  r = Polygon(hdcDevice, ptStartPoint, iPointCount)

  '  Replace the old pen and brush, and delete the new ones.
  
  r = SelectObject(hdcDevice, hOldPen)
  r = SelectObject(hdcDevice, hOldBrush)
  DeleteObject (hPen)
  DeleteObject (hBrush)

  FillPolygon = r
  
End Function

